diff --git a/app/proc_info/main.c b/app/proc_info/main.c
index 6448d7b..341176d 100644
--- a/app/proc_info/main.c
+++ b/app/proc_info/main.c
@@ -42,7 +42,6 @@
 #include <getopt.h>
 
 #include <rte_eal.h>
-#include <rte_config.h>
 #include <rte_common.h>
 #include <rte_debug.h>
 #include <rte_ethdev.h>
diff --git a/app/test/test_power_kvm_vm.c b/app/test/test_power_kvm_vm.c
index 6fdb344..ff468c1 100644
--- a/app/test/test_power_kvm_vm.c
+++ b/app/test/test_power_kvm_vm.c
@@ -40,7 +40,6 @@
 #include "test.h"
 
 #include <rte_power.h>
-#include <rte_config.h>
 
 #define TEST_POWER_VM_LCORE_ID            0U
 #define TEST_POWER_VM_LCORE_OUT_OF_BOUNDS (RTE_MAX_LCORE+1)
diff --git a/drivers/crypto/aesni_mb/rte_aesni_mb_pmd.c b/drivers/crypto/aesni_mb/rte_aesni_mb_pmd.c
index d8ccf05..2ede7c1 100644
--- a/drivers/crypto/aesni_mb/rte_aesni_mb_pmd.c
+++ b/drivers/crypto/aesni_mb/rte_aesni_mb_pmd.c
@@ -31,7 +31,6 @@
  */
 
 #include <rte_common.h>
-#include <rte_config.h>
 #include <rte_hexdump.h>
 #include <rte_cryptodev.h>
 #include <rte_cryptodev_pmd.h>
diff --git a/drivers/net/mlx4/mlx4.c b/drivers/net/mlx4/mlx4.c
index 207bfe2..ee00151 100644
--- a/drivers/net/mlx4/mlx4.c
+++ b/drivers/net/mlx4/mlx4.c
@@ -73,7 +73,6 @@
 #ifdef PEDANTIC
 #pragma GCC diagnostic ignored "-pedantic"
 #endif
-#include <rte_config.h>
 #include <rte_ether.h>
 #include <rte_ethdev.h>
 #include <rte_dev.h>
diff --git a/examples/l2fwd-ivshmem/host/host.c b/examples/l2fwd-ivshmem/host/host.c
index d923711..6e6ed5e 100644
--- a/examples/l2fwd-ivshmem/host/host.c
+++ b/examples/l2fwd-ivshmem/host/host.c
@@ -41,7 +41,6 @@
 #include <signal.h>
 
 #include <rte_eal.h>
-#include <rte_config.h>
 #include <rte_cycles.h>
 #include <rte_eal_memconfig.h>
 #include <rte_debug.h>
diff --git a/examples/performance-thread/common/lthread.c b/examples/performance-thread/common/lthread.c
index e8addb7..8fbff73 100644
--- a/examples/performance-thread/common/lthread.c
+++ b/examples/performance-thread/common/lthread.c
@@ -74,7 +74,6 @@
 #include <sys/time.h>
 #include <sys/mman.h>
 
-#include <rte_config.h>
 #include <rte_log.h>
 #include <ctx.h>
 
diff --git a/examples/performance-thread/common/lthread_cond.c b/examples/performance-thread/common/lthread_cond.c
index 8885a09..96fcce0 100644
--- a/examples/performance-thread/common/lthread_cond.c
+++ b/examples/performance-thread/common/lthread_cond.c
@@ -73,7 +73,6 @@
 #include <sys/mman.h>
 #include <errno.h>
 
-#include <rte_config.h>
 #include <rte_log.h>
 #include <rte_common.h>
 
diff --git a/examples/performance-thread/common/lthread_diag.c b/examples/performance-thread/common/lthread_diag.c
index 1913c25..bce1a0c 100644
--- a/examples/performance-thread/common/lthread_diag.c
+++ b/examples/performance-thread/common/lthread_diag.c
@@ -31,7 +31,6 @@
  *   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
 
-#include <rte_config.h>
 #include <rte_log.h>
 #include <rte_common.h>
 
diff --git a/examples/performance-thread/common/lthread_mutex.c b/examples/performance-thread/common/lthread_mutex.c
index 074d066..af8b82d 100644
--- a/examples/performance-thread/common/lthread_mutex.c
+++ b/examples/performance-thread/common/lthread_mutex.c
@@ -44,7 +44,6 @@
 #include <sys/time.h>
 #include <sys/mman.h>
 
-#include <rte_config.h>
 #include <rte_per_lcore.h>
 #include <rte_log.h>
 #include <rte_spinlock.h>
diff --git a/examples/performance-thread/common/lthread_sched.c b/examples/performance-thread/common/lthread_sched.c
index 3fad768..ae698c4 100644
--- a/examples/performance-thread/common/lthread_sched.c
+++ b/examples/performance-thread/common/lthread_sched.c
@@ -76,7 +76,6 @@
 #include <sys/mman.h>
 #include <sched.h>
 
-#include <rte_config.h>
 #include <rte_prefetch.h>
 #include <rte_per_lcore.h>
 #include <rte_atomic.h>
diff --git a/examples/performance-thread/common/lthread_tls.c b/examples/performance-thread/common/lthread_tls.c
index 1c6cf11..43cda4f 100644
--- a/examples/performance-thread/common/lthread_tls.c
+++ b/examples/performance-thread/common/lthread_tls.c
@@ -45,7 +45,6 @@
 #include <execinfo.h>
 #include <sched.h>
 
-#include <rte_config.h>
 #include <rte_malloc.h>
 #include <rte_log.h>
 #include <rte_ring.h>
diff --git a/examples/performance-thread/pthread_shim/Makefile b/examples/performance-thread/pthread_shim/Makefile
index 9cf32e3..86ac657 100644
--- a/examples/performance-thread/pthread_shim/Makefile
+++ b/examples/performance-thread/pthread_shim/Makefile
@@ -46,7 +46,7 @@ SRCS-y := main.c  pthread_shim.c
 INCLUDES := -I$(RTE_SDK)/$(RTE_TARGET)/include -I$(SRCDIR)
 include $(RTE_SDK)/examples/performance-thread/common/common.mk
 
-CFLAGS=    -g -O3 $(USER_FLAGS) $(INCLUDES)
+CFLAGS += -g -O3 $(USER_FLAGS) $(INCLUDES)
 CFLAGS += $(WERROR_FLAGS)
 
 LDFLAGS += -lpthread
diff --git a/examples/performance-thread/pthread_shim/main.c b/examples/performance-thread/pthread_shim/main.c
index dab379a..f035721 100644
--- a/examples/performance-thread/pthread_shim/main.c
+++ b/examples/performance-thread/pthread_shim/main.c
@@ -47,7 +47,6 @@
 #include <sched.h>
 #include <pthread.h>
 
-#include <rte_config.h>
 #include <rte_common.h>
 #include <rte_lcore.h>
 #include <rte_per_lcore.h>
diff --git a/examples/performance-thread/pthread_shim/pthread_shim.c b/examples/performance-thread/pthread_shim/pthread_shim.c
index 0fd36ba..93c3216 100644
--- a/examples/performance-thread/pthread_shim/pthread_shim.c
+++ b/examples/performance-thread/pthread_shim/pthread_shim.c
@@ -39,7 +39,6 @@
 #include <sched.h>
 #include <dlfcn.h>
 
-#include <rte_config.h>
 #include <rte_log.h>
 
 #include "lthread_api.h"
diff --git a/examples/vm_power_manager/channel_manager.c b/examples/vm_power_manager/channel_manager.c
index ceaf95d..22c2ddd 100644
--- a/examples/vm_power_manager/channel_manager.c
+++ b/examples/vm_power_manager/channel_manager.c
@@ -45,7 +45,6 @@
 #include <sys/socket.h>
 #include <sys/select.h>
 
-#include <rte_config.h>
 #include <rte_malloc.h>
 #include <rte_memory.h>
 #include <rte_mempool.h>
diff --git a/examples/vm_power_manager/channel_monitor.c b/examples/vm_power_manager/channel_monitor.c
index 7003ddf..e7f5cc4 100644
--- a/examples/vm_power_manager/channel_monitor.c
+++ b/examples/vm_power_manager/channel_monitor.c
@@ -42,7 +42,6 @@
 #include <sys/epoll.h>
 #include <sys/queue.h>
 
-#include <rte_config.h>
 #include <rte_log.h>
 #include <rte_memory.h>
 #include <rte_malloc.h>
diff --git a/examples/vm_power_manager/guest_cli/main.c b/examples/vm_power_manager/guest_cli/main.c
index 7ee2296..5ac98ed 100644
--- a/examples/vm_power_manager/guest_cli/main.c
+++ b/examples/vm_power_manager/guest_cli/main.c
@@ -48,7 +48,6 @@
 #include <rte_lcore.h>
 #include <rte_power.h>
 #include <rte_debug.h>
-#include <rte_config.h>
 
 #include "vm_power_cli_guest.h"
 
diff --git a/examples/vm_power_manager/guest_cli/vm_power_cli_guest.c b/examples/vm_power_manager/guest_cli/vm_power_cli_guest.c
index 75e544a..7931135 100644
--- a/examples/vm_power_manager/guest_cli/vm_power_cli_guest.c
+++ b/examples/vm_power_manager/guest_cli/vm_power_cli_guest.c
@@ -43,7 +43,6 @@
 #include <cmdline_parse_num.h>
 #include <cmdline_socket.h>
 #include <cmdline.h>
-#include <rte_config.h>
 #include <rte_log.h>
 #include <rte_lcore.h>
 
diff --git a/examples/vm_power_manager/main.c b/examples/vm_power_manager/main.c
index dfca7b8..97178d1 100644
--- a/examples/vm_power_manager/main.c
+++ b/examples/vm_power_manager/main.c
@@ -52,7 +52,6 @@
 #include <rte_per_lcore.h>
 #include <rte_lcore.h>
 #include <rte_debug.h>
-#include <rte_config.h>
 
 #include "channel_manager.h"
 #include "channel_monitor.h"
diff --git a/examples/vm_power_manager/power_manager.c b/examples/vm_power_manager/power_manager.c
index 60da96c..2644fce 100644
--- a/examples/vm_power_manager/power_manager.c
+++ b/examples/vm_power_manager/power_manager.c
@@ -43,7 +43,6 @@
 
 #include <sys/types.h>
 
-#include <rte_config.h>
 #include <rte_log.h>
 #include <rte_power.h>
 #include <rte_spinlock.h>
diff --git a/examples/vm_power_manager/vm_power_cli.c b/examples/vm_power_manager/vm_power_cli.c
index 7690d14..c5e8d93 100644
--- a/examples/vm_power_manager/vm_power_cli.c
+++ b/examples/vm_power_manager/vm_power_cli.c
@@ -45,7 +45,6 @@
 #include <cmdline_parse_num.h>
 #include <cmdline_socket.h>
 #include <cmdline.h>
-#include <rte_config.h>
 
 #include "vm_power_cli.h"
 #include "channel_manager.h"
diff --git a/lib/librte_eal/linuxapp/kni/kni_misc.c b/lib/librte_eal/linuxapp/kni/kni_misc.c
index f5f18f0..ae8133f 100644
--- a/lib/librte_eal/linuxapp/kni/kni_misc.c
+++ b/lib/librte_eal/linuxapp/kni/kni_misc.c
@@ -35,7 +35,6 @@
 
 #include <exec-env/rte_kni_common.h>
 #include "kni_dev.h"
-#include <rte_config.h>
 
 MODULE_LICENSE("Dual BSD/GPL");
 MODULE_AUTHOR("Intel Corporation");
diff --git a/lib/librte_eal/linuxapp/kni/kni_net.c b/lib/librte_eal/linuxapp/kni/kni_net.c
index ab5add4..e02edcb 100644
--- a/lib/librte_eal/linuxapp/kni/kni_net.c
+++ b/lib/librte_eal/linuxapp/kni/kni_net.c
@@ -36,7 +36,6 @@
 #include <linux/kthread.h>
 #include <linux/delay.h>
 
-#include <rte_config.h>
 #include <exec-env/rte_kni_common.h>
 #include <kni_fifo.h>
 #include "kni_dev.h"
diff --git a/lib/librte_eal/linuxapp/xen_dom0/dom0_mm_misc.c b/lib/librte_eal/linuxapp/xen_dom0/dom0_mm_misc.c
index bfe0af8..79630ba 100644
--- a/lib/librte_eal/linuxapp/xen_dom0/dom0_mm_misc.c
+++ b/lib/librte_eal/linuxapp/xen_dom0/dom0_mm_misc.c
@@ -71,7 +71,6 @@
 #include <xen/xen-ops.h>
 #include <xen/interface/memory.h>
 
-#include <rte_config.h>
 #include <exec-env/rte_dom0_common.h>
 
 #include "compat.h"
diff --git a/lib/librte_power/guest_channel.c b/lib/librte_power/guest_channel.c
index 2295665..d6b6d0a 100644
--- a/lib/librte_power/guest_channel.c
+++ b/lib/librte_power/guest_channel.c
@@ -42,7 +42,6 @@
 
 
 #include <rte_log.h>
-#include <rte_config.h>
 
 #include "guest_channel.h"
 #include "channel_commands.h"
diff --git a/lib/librte_power/rte_power_kvm_vm.c b/lib/librte_power/rte_power_kvm_vm.c
index 11596c3..7bb2774 100644
--- a/lib/librte_power/rte_power_kvm_vm.c
+++ b/lib/librte_power/rte_power_kvm_vm.c
@@ -34,7 +34,6 @@
 #include <string.h>
 
 #include <rte_log.h>
-#include <rte_config.h>
 
 #include "guest_channel.h"
 #include "channel_commands.h"